import express from 'express';
export interface IResponse {
    data: any;
}
export declare class Response<T extends IResponse> {
    data: any;
}
export declare abstract class BaseController {
    constructor();
    abstract execute(request: express.Request, response: express.Response, next: express.NextFunction): Promise<Response<IResponse>>;
    protected ok<T>(response: express.Response, data?: T): express.Response<any, Record<string, any>>;
    protected created(response: express.Response): express.Response<any, Record<string, any>>;
    protected clientError(next: express.NextFunction, message?: string): void;
    protected unauthorized(next: express.NextFunction, message?: string): void;
    protected paymentRequired(next: express.NextFunction, message?: string): void;
    protected forbidden(next: express.NextFunction, message?: string): void;
    protected notFound(next: express.NextFunction, message?: string): void;
    protected conflict(next: express.NextFunction, message?: string): void;
    protected tooMany(next: express.NextFunction, message?: string): void;
}
